Index: drivers/filesystems/btrfs/treefuncs.c
===================================================================
--- drivers/filesystems/btrfs/treefuncs.c	(révision 75772)
+++ drivers/filesystems/btrfs/treefuncs.c	(copie de travail)
@@ -1910,22 +1908,157 @@
                             ended = TRUE;
                             break;
                         }
-                        
+
                         le2 = le2->Flink;
                     }
                 }
             }
+        } else if (bi->operation == Batch_DeleteExtentData) {
+            if (tp.item->key.obj_id < bi->key.obj_id || (tp.item->key.obj_id == bi->key.obj_id && tp.item->key.obj_type < bi->key.obj_type)) {
+                traverse_ptr tp2;
+
+                if (find_next_item(Vcb, &tp, &tp2, FALSE, Irp)) {
+                    if (tp2.item->key.obj_id == bi->key.obj_id && tp2.item->key.obj_type == bi->key.obj_type) {
+                        tp = tp2;
+                        find_tree_end(tp.tree, &tree_end, &no_end);
+                    }
+                }
+            }
+
+            if (tp.item->key.obj_id == bi->key.obj_id && tp.item->key.obj_type == bi->key.obj_type) {
+                BOOL ended = FALSE;
+
+                td = tp.item;
+
+                if (!tp.item->ignore) {
+                    tp.item->ignore = TRUE;
+                    tp.tree->header.num_items--;
+                    tp.tree->size -= tp.item->size + sizeof(leaf_node);
+                    tp.tree->write = TRUE;
+                }
+
+                le2 = tp.item->list_entry.Flink;
+                while (le2 != &tp.tree->itemlist) {
+                    td = CONTAINING_RECORD(le2, tree_data, list_entry);
+
+                    if (td->key.obj_id == bi->key.obj_id && td->key.obj_type == bi->key.obj_type) {
+                        if (!td->ignore) {
+                            td->ignore = TRUE;
+                            tp.tree->header.num_items--;
+                            tp.tree->size -= td->size + sizeof(leaf_node);
+                            tp.tree->write = TRUE;
+                        }
+                    } else {
+                        ended = TRUE;
+                        break;
+                    }
+
+                    le2 = le2->Flink;
+                }
+
+                while (!ended) {
+                    traverse_ptr next_tp;
+
+                    tp.item = td;
+
+                    if (!find_next_item(Vcb, &tp, &next_tp, FALSE, Irp))
+                        break;
+
+                    tp = next_tp;
+
+                    le2 = &tp.item->list_entry;
+                    while (le2 != &tp.tree->itemlist) {
+                        td = CONTAINING_RECORD(le2, tree_data, list_entry);
+
+                        if (td->key.obj_id == bi->key.obj_id && td->key.obj_type == bi->key.obj_type) {
+                            if (!td->ignore) {
+                                td->ignore = TRUE;
+                                tp.tree->header.num_items--;
+                                tp.tree->size -= td->size + sizeof(leaf_node);
+                                tp.tree->write = TRUE;
+                            }
+                        } else {
+                            ended = TRUE;
+                            break;
+                        }
+
+                        le2 = le2->Flink;
+                    }
+                }
+            }
+        } else if (bi->operation == Batch_DeleteFreeSpace) {
+            if (tp.item->key.obj_id >= bi->key.obj_id && tp.item->key.obj_id < bi->key.obj_id + bi->key.offset) {
+                BOOL ended = FALSE;
+
+                td = tp.item;
+
+                if (!tp.item->ignore) {
+                    tp.item->ignore = TRUE;
+                    tp.tree->header.num_items--;
+                    tp.tree->size -= tp.item->size + sizeof(leaf_node);
+                    tp.tree->write = TRUE;
+                }
+
+                le2 = tp.item->list_entry.Flink;
+                while (le2 != &tp.tree->itemlist) {
+                    td = CONTAINING_RECORD(le2, tree_data, list_entry);
+
+                    if (td->key.obj_id >= bi->key.obj_id && td->key.obj_id < bi->key.obj_id + bi->key.offset) {
+                        if (!td->ignore) {
+                            td->ignore = TRUE;
+                            tp.tree->header.num_items--;
+                            tp.tree->size -= td->size + sizeof(leaf_node);
+                            tp.tree->write = TRUE;
+                        }
+                    } else {
+                        ended = TRUE;
+                        break;
+                    }
+
+                    le2 = le2->Flink;
+                }
+
+                while (!ended) {
+                    traverse_ptr next_tp;
+
+                    tp.item = td;
+
+                    if (!find_next_item(Vcb, &tp, &next_tp, FALSE, Irp))
+                        break;
+
+                    tp = next_tp;
+
+                    le2 = &tp.item->list_entry;
+                    while (le2 != &tp.tree->itemlist) {
+                        td = CONTAINING_RECORD(le2, tree_data, list_entry);
+
+                        if (td->key.obj_id >= bi->key.obj_id && td->key.obj_id < bi->key.obj_id + bi->key.offset) {
+                            if (!td->ignore) {
+                                td->ignore = TRUE;
+                                tp.tree->header.num_items--;
+                                tp.tree->size -= td->size + sizeof(leaf_node);
+                                tp.tree->write = TRUE;
+                            }
+                        } else {
+                            ended = TRUE;
+                            break;
+                        }
+
+                        le2 = le2->Flink;
+                    }
+                }
+            }
         } else {
-            if (bi->operation == Batch_Delete || bi->operation == Batch_DeleteDirItem ||
-                bi->operation == Batch_DeleteInodeRef || bi->operation == Batch_DeleteInodeExtRef)
+            if (bi->operation == Batch_Delete || bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef ||
+                bi->operation == Batch_DeleteInodeExtRef || bi->operation == Batch_DeleteXattr)
                 td = NULL;
             else {
                 td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
                 if (!td) {
                     ERR("out of memory\n");
-                    return;
+                    return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 td->key = bi->key;
                 td->size = bi->datalen;
                 td->data = bi->data;
@@ -1932,13 +2065,13 @@
                 td->ignore = FALSE;
                 td->inserted = TRUE;
             }
-            
+
             cmp = keycmp(bi->key, tp.item->key);
-            
+
             if (cmp == -1) { // very first key in root
                 if (td) {
                     tree_data* paritem;
-                    
+
                     InsertHeadList(&tp.tree->itemlist, &td->list_entry);
 
                     paritem = tp.tree->paritem;
@@ -1947,74 +2080,74 @@
                             paritem->key = bi->key;
                         } else
                             break;
-                        
+
                         paritem = paritem->treeholder.tree->paritem;
                     }
                 }
             } else if (cmp == 0) { // item already exists
-                ignore = handle_batch_collision(Vcb, bi, tp.tree, tp.item, td, &br->items, rollback);
+                if (tp.item->ignore) {
+                    if (td)
+                        InsertHeadList(tp.item->list_entry.Blink, &td->list_entry);
+                } else {
+                    Status = handle_batch_collision(Vcb, bi, tp.tree, tp.item, td, &br->items, &ignore);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("handle_batch_collision returned %08x\n", Status);
+
+                        if (td)
+                            ExFreeToPagedLookasideList(&Vcb->tree_data_lookaside, td);
+
+                        return Status;
+                    }
+                }
             } else if (td) {
                 InsertHeadList(&tp.item->list_entry, &td->list_entry);
             }
-            
+
             if (bi->operation == Batch_DeleteInodeRef && cmp != 0 && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                 add_delete_inode_extref(Vcb, bi, &br->items);
             }
-            
+
             if (!ignore && td) {
                 tp.tree->header.num_items++;
                 tp.tree->size += bi->datalen + sizeof(leaf_node);
                 tp.tree->write = TRUE;
-                
-                if (rollback) {
-                    // FIXME - free this correctly
-                    tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                    if (!tp2) {
-                        ERR("out of memory\n");
-                        return;
-                    }
-                    
-                    tp2->tree = tp.tree;
-                    tp2->item = td;
 
-                    add_rollback(Vcb, rollback, ROLLBACK_INSERT_ITEM, tp2);
-                }
-                
-                listhead = &td->list_entry;
-            } else {
-                listhead = &tp.item->list_entry;
-                
-                if (!td && tp.item->ignore && tp.item->list_entry.Blink != &tp.tree->itemlist) {
-                    tree_data* prevtd = CONTAINING_RECORD(tp.item->list_entry.Blink, tree_data, list_entry);
-                    
-                    if (!prevtd->ignore && !keycmp(prevtd->key, tp.item->key))
-                        listhead = &prevtd->list_entry;
-                }
+                listhead = td;
+            } else
+                listhead = tp.item;
+
+            while (listhead->list_entry.Blink != &tp.tree->itemlist) {
+                tree_data* prevtd = CONTAINING_RECORD(listhead->list_entry.Blink, tree_data, list_entry);
+
+                if (!keycmp(prevtd->key, listhead->key))
+                    listhead = prevtd;
+                else
+                    break;
             }
-            
+
             le2 = le->Flink;
             while (le2 != &br->items) {
                 batch_item* bi2 = CONTAINING_RECORD(le2, batch_item, list_entry);
-                
-                if (bi2->operation == Batch_DeleteInode)
+
+                if (bi2->operation == Batch_DeleteInode || bi2->operation == Batch_DeleteExtentData || bi2->operation == Batch_DeleteFreeSpace)
                     break;
-                
+
                 if (no_end || keycmp(bi2->key, tree_end) == -1) {
                     LIST_ENTRY* le3;
                     BOOL inserted = FALSE;
-                    
+
                     ignore = FALSE;
-                    
-                    if (bi2->operation == Batch_Delete || bi2->operation == Batch_DeleteDirItem ||
-                        bi2->operation == Batch_DeleteInodeRef || bi2->operation == Batch_DeleteInodeExtRef)
+
+                    if (bi2->operation == Batch_Delete || bi2->operation == Batch_DeleteDirItem || bi2->operation == Batch_DeleteInodeRef ||
+                        bi2->operation == Batch_DeleteInodeExtRef || bi2->operation == Batch_DeleteXattr)
                         td = NULL;
                     else {
                         td = ExAllocateFromPagedLookasideList(&Vcb->tree_data_lookaside);
                         if (!td) {
                             ERR("out of memory\n");
-                            return;
+                            return STATUS_INSUFFICIENT_RESOURCES;
                         }
-                        
+
                         td->key = bi2->key;
                         td->size = bi2->datalen;
                         td->data = bi2->data;
@@ -2021,19 +2154,15 @@
                         td->ignore = FALSE;
                         td->inserted = TRUE;
                     }
-                    
-                    le3 = listhead;
+
+                    le3 = &listhead->list_entry;
                     while (le3 != &tp.tree->itemlist) {
                         tree_data* td2 = CONTAINING_RECORD(le3, tree_data, list_entry);
-                        
-                        if (!td2->ignore) {
-                            cmp = keycmp(bi2->key, td2->key);
 
-                            if (cmp == 0) {
-                                ignore = handle_batch_collision(Vcb, bi2, tp.tree, td2, td, &br->items, rollback);
-                                inserted = TRUE;
-                                break;
-                            } else if (cmp == -1) {
+                        cmp = keycmp(bi2->key, td2->key);
+
+                        if (cmp == 0) {
+                            if (td2->ignore) {
                                 if (td) {
                                     InsertHeadList(le3->Blink, &td->list_entry);
                                     inserted = TRUE;
@@ -2040,48 +2169,59 @@
                                 } else if (bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                                     add_delete_inode_extref(Vcb, bi2, &br->items);
                                 }
-                                break;
+                            } else {
+                                Status = handle_batch_collision(Vcb, bi2, tp.tree, td2, td, &br->items, &ignore);
+                                if (!NT_SUCCESS(Status)) {
+                                    ERR("handle_batch_collision returned %08x\n", Status);
+                                    return Status;
+                                }
                             }
+
+                            inserted = TRUE;
+                            break;
+                        } else if (cmp == -1) {
+                            if (td) {
+                                InsertHeadList(le3->Blink, &td->list_entry);
+                                inserted = TRUE;
+                            } else if (bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
+                                add_delete_inode_extref(Vcb, bi2, &br->items);
+                            }
+                            break;
                         }
-                        
+
                         le3 = le3->Flink;
                     }
-                    
+
                     if (td) {
                         if (!inserted)
                             InsertTailList(&tp.tree->itemlist, &td->list_entry);
-                        
+
                         if (!ignore) {
                             tp.tree->header.num_items++;
                             tp.tree->size += bi2->datalen + sizeof(leaf_node);
-                            
-                            if (rollback) {
-                                // FIXME - free this correctly
-                                tp2 = ExAllocateFromPagedLookasideList(&Vcb->traverse_ptr_lookaside);
-                                if (!tp2) {
-                                    ERR("out of memory\n");
-                                    return;
-                                }
-                                
-                                tp2->tree = tp.tree;
-                                tp2->item = td;
-                                
-                                add_rollback(Vcb, rollback, ROLLBACK_INSERT_ITEM, tp2);
-                            }
-                            
-                            listhead = &td->list_entry;
+
+                            listhead = td;
                         }
                     } else if (!inserted && bi2->operation == Batch_DeleteInodeRef && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_EXTENDED_IREF) {
                         add_delete_inode_extref(Vcb, bi2, &br->items);
                     }
-                    
+
+                    while (listhead->list_entry.Blink != &tp.tree->itemlist) {
+                        tree_data* prevtd = CONTAINING_RECORD(listhead->list_entry.Blink, tree_data, list_entry);
+
+                        if (!keycmp(prevtd->key, listhead->key))
+                            listhead = prevtd;
+                        else
+                            break;
+                    }
+
                     le = le2;
                 } else
                     break;
-                
+
                 le2 = le2->Flink;
             }
-            
+
             t = tp.tree;
             while (t) {
                 if (t->paritem && t->paritem->ignore) {
@@ -2088,8 +2228,6 @@
                     t->paritem->ignore = FALSE;
                     t->parent->header.num_items++;
                     t->parent->size += sizeof(internal_node);
-                    
-                    // FIXME - do we need to add a rollback entry here?
                 }
 
                 t->header.generation = Vcb->superblock.generation;
@@ -2096,29 +2234,39 @@
                 t = t->parent;
             }
         }
-        
+
         le = le->Flink;
     }
-    
+
     // FIXME - remove as we are going along
     while (!IsListEmpty(&br->items)) {
-        LIST_ENTRY* le = RemoveHeadList(&br->items);
-        batch_item* bi = CONTAINING_RECORD(le, batch_item, list_entry);
-        
-        if ((bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef || bi->operation == Batch_DeleteInodeExtRef) && bi->data)
+        batch_item* bi = CONTAINING_RECORD(RemoveHeadList(&br->items), batch_item, list_entry);
+
+        if ((bi->operation == Batch_DeleteDirItem || bi->operation == Batch_DeleteInodeRef ||
+            bi->operation == Batch_DeleteInodeExtRef || bi->operation == Batch_DeleteXattr) && bi->data)
             ExFreePool(bi->data);
-        
+
         ExFreeToPagedLookasideList(&Vcb->batch_item_lookaside, bi);
     }
+
+    return STATUS_SUCCESS;
 }
 
-void commit_batch_list(device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS commit_batch_list(_Requires_exclusive_lock_held_(_Curr_->tree_lock) device_extension* Vcb, LIST_ENTRY* batchlist, PIRP Irp) {
+    NTSTATUS Status;
+
     while (!IsListEmpty(batchlist)) {
         LIST_ENTRY* le = RemoveHeadList(batchlist);
         batch_root* br2 = CONTAINING_RECORD(le, batch_root, list_entry);
-        
-        commit_batch_list_root(Vcb, br2, Irp, rollback);
-        
+
+        Status = commit_batch_list_root(Vcb, br2, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("commit_batch_list_root returned %08x\n", Status);
+            return Status;
+        }
+
         ExFreePool(br2);
     }
+
+    return STATUS_SUCCESS;
 }
